function initializeFolderFunctions(folder)
{
  folder.initialize = initializeFolder 
  folder.setState = setStateFolder 
  folder.addChild = addChild 
  folder.addChildren = addChildren
  folder.hasChildren = hasChildren
  folder.createIndex = createEntryIndex 
  folder.setVisibility = setVisibility
  folder.redraw = redrawFolder 
  folder.folderMstr = folderMstr 
  folder.displayObject = paintFolder 
  folder.totalHeight = totalHeight 
  folder.subEntries = folderSubEntries 
  folder.linkHTML = linkFolderHTML
  folder.startHTML = startHTML
  folder.endHTML = endHTML
  folder.nodeImageSource = nodeImageSource
  folder.folderImageSrc = folderImageSrc
  folder.getID = getID
  folder.forceOpenFolders = forceOpenFolders
}

function initializeDynamicFolderData(folder)
{
  folder.isOpen = false
  folder.isLastOpenedFolder = false
  folder.isDisplayed = 0
}

function initializeFolderData(folder,description, target,hreference)
{
  folder.description = description; 
  folder.hreference = hreference;
  folder.target = target;
  folder.id = -1;
  folder.navigationObject = 0;
  folder.folderImage = 0; 
  folder.nodeImage = 0;
  folder.isLastNode = 0;
  folder.iconSrc = ImagePath + "folderopen.gif";
  folder.iconSrcClosed = ImagePath + "folderclosed.gif";
  folder.children = new Array;
  folder.numberOfChildren = 0;
  folder.level = 0;
  folder.leftSideCoded = "";
  folder.isLastNode=false;
  folder.parentObj = null;
  folder.maySelect=true;
  folder.additionalHTML = ""
}

function Folder(description, target,hreference) //constructor 
{ 
  initializeDynamicFolderData(this)
  initializeFolderData(this,description, target,hreference)
  initializeFolderFunctions(this)
} 

function hasChildren()
{
  return this.numberOfChildren 
}
 
function initializeChild(tree,child,level,leftSide,last)
{
  if (typeof child.initialize == 'undefined')
  {
    if (typeof child[0] == 'undefined' || typeof child == 'string')
    {
      child = ["item incorrectly defined", ""];
    }
    child.initialize=initializeItem;
    child.createIndex=createEntryIndex;
    if (typeof child.maySelect == 'undefined')
      child.maySelect=true
    child.forceOpenFolders = forceOpenFolders
  }
  if (last) 
    child.initialize(tree,level, 1, leftSide)
  else 
    child.initialize(tree,level, 0, leftSide)
}
 
function initializeFolder(tree,level, lastNode, leftSide) 
{ 
  var j=0 
  var i=0       
  var last 
  this.createIndex(tree) 
  this.level = level
  this.leftSideCoded = leftSide

  if (browserVersion == 0 || tree.StartAllExpanded==1)
    this.isOpen=true;

  if (level>0)
    if (lastNode) //the last child
      leftSide = leftSide + "0"
    else
      leftSide = leftSide + "1"
  this.isLastNode = lastNode
  if (this.hasChildren() > 0) 
  { 
    level = level + 1 
    for (i=0 ; i < this.numberOfChildren; i++)  
      initializeChild(tree,this.children[i],level,leftSide,i == this.numberOfChildren-1)
  } 
} 
 
function paintFolder(tree,insertAtObject) 
{ 
var nodeName = ""
var link = ""
var str = ""
var i=0

  finalizeCreationOfChildDocuments(this)
  
  var leftSide = leftSideHTML(this.leftSideCoded)
  if (browserVersion > 0) 
    link = "<a class='ExplorerFolder' href='javascript:clickOnNode(\""+tree.getID()+"\",\""+this.getID()+"\")'>" 
  else 
    link = "<a class='ExplorerFolder'>" 

  nodeName = this.nodeImageSource()
  if (this.level>0) 
    if (this.isLastNode) //the last child
      leftSide = leftSide + "<td valign=top>" + link + "<img name='nodeImage" + this.id +tree.getID()+ "' id='nodeImage" + this.id + tree.getID()+ "' src='" + nodeName + "' width=16 height=22 border=0></a></td>"
    else 
      leftSide = leftSide + "<td valign=top background=" + ImagePath + "vertline.gif>" + link + "<img name='nodeImage" + this.id + tree.getID()+ "' id='nodeImage" + this.id + tree.getID()+ "' src='" + nodeName + "' width=16 height=22 border=0></a></td>"
  this.isDisplayed = 1

  if (browserVersion == 2) { 
    if (!document.yPosition) 
      document.yPosition=20 
  } 
  str = this.startHTML("folder",tree);
  str = str + "<tr>" + leftSide + "<td valign=top>";
  if (tree.UseFolderIcons)
  {
    str = str + this.linkHTML(tree,false) 
    str = str + "<img id='folderImage" + this.id+ tree.getID() + "' name='folderIcon" + this.id+ tree.getID() + "' src='" + this.folderImageSrc() + "' border=0></a>"
  }
  else
  {
    if (this.additionalHTML == "")
    str = str + "<img src=" + ImagePath + "blank.gif height=2 width=2>"
  }
  if (tree.WrapText)
    str = str + "</td>"+this.additionalHTML+"<td valign=middle width=100%>"
  else
    str = str + "</td>"+this.additionalHTML+"<td valign=middle nowrap width=100%>"
  if (TextAsLink) 
  { 
    str = str + this.linkHTML(tree,true) 
    str = str + this.description+ "</a>"
  } 
  else 
    str = str + this.desc
  str = str + "</td>"

  str = str + this.endHTML()

  if (insertAtObject == null)
  {
    if (supportsDeferral) {
      document.write("<div id=domainRoot"+tree.getID()+"></div>") 
      insertAtObject = getElById("domainRoot"+tree.getID())
      if(insertAtObject!=null)
        insertAtObject.insertAdjacentHTML("beforeEnd", str)
      else
        document.write(str);
    }
    else
      document.write(str)
  }
  else
  {
    insertAtObject.insertAdjacentHTML("afterEnd", str)
  }
 
  if (browserVersion == 2) 
  { 
    this.navigationObject = document.layers["folder"+this.id+tree.getID()] 
    if (tree.UseFolderIcons)
      this.folderImage = this.navigationObject.document.images["folderImage"+this.id+tree.getID()] 
    this.nodeImage = this.navigationObject.document.images["nodeImage"+this.id+tree.getID()] 
    document.yPosition=document.yPosition+this.navigationObject.clip.height 
  } 
  else if (browserVersion != 0)
  { 
    this.navigationObject = getElById("folder"+this.id+tree.getID())
    if (tree.UseFolderIcons)
      this.folderImage = getElById("folderImage"+this.id+tree.getID()) 
    this.nodeImage = getElById("nodeImage"+this.id+tree.getID())
  } 
} 
 
function setStateFolder(tree,isOpen) 
{ 
  var subEntries 
  var totalHeight 
  var fIt = 0 
  var i=0 
  var currentOpen
 
  if (isOpen == this.isOpen) 
    return 

  if (browserVersion == 2)  
  { 
    totalHeight = 0 
    for (i=0; i < this.numberOfChildren; i++) 
      totalHeight = totalHeight + this.children[i].navigationObject.clip.height 
    subEntries = this.subEntries() 
    if (this.isOpen) 
      totalHeight = 0 - totalHeight 
    for (fIt = this.id + subEntries + 1; fIt < tree.numberOfEntries; fIt++) 
      tree.indexOfEntries[fIt].navigationObject.moveBy(0, totalHeight) 
  }  
  this.isOpen = isOpen;
  if (this.getID()!=tree.getID() && tree.KeepState && !this.isOpen) //closing
  {
     currentOpen = GetCookie(tree,"clickedFolder")
     if (currentOpen != null) {
         currentOpen = currentOpen.replace(this.getID()+cookieCutter, "")
         SetCookie(tree,"clickedFolder", currentOpen)
     }
  }
  if (!this.isOpen && this.isLastOpenedfolder)
  {
    tree.lastOpenedFolder = null;
    this.isLastOpenedfolder = false;
  }
  activateChangesInState(tree,this) 
} 
 
function activateChangesInState(tree,folder) 
{   
  var i=0 

  //Shift the icon
  if (folder.numberOfChildren > 0 && folder.level>0)  
    folder.nodeImage.src = folder.nodeImageSource()

  //Shift node
  if (tree.UseFolderIcons)
    folder.folderImage.src = folder.folderImageSrc()

  //Propagate changes
  for (i=folder.numberOfChildren-1; i>=0; i--) {
    if (folder.isOpen) 
      folder.children[i].folderMstr(tree,folder.navigationObject)
    else 
      folder.children[i].redraw(tree) 
  }
} 
 
function redrawFolder(tree) 
{ 
  this.setVisibility()
  this.setState(tree,0) 
} 
 
function linkFolderHTML(tree,isTextLink) 
{ 
  var str = "";
  var link;
  if (this.hreference) 
  { 
       if (this.target) 
	  str = str + "<a class='ExplorerFolder' href='" + this.hreference + "' TARGET=\""+this.target+"\" "
	else
	  str = str + "<a class='ExplorerFolder' href='" + this.hreference + "' TARGET=_top "
        
    if (isTextLink) {
        str += "id=\"itemTextLink"+tree.getID()+this.id+"\" ";
    }

    if (browserVersion > 0) 
      str = str + "onClick='javascript:clickOnFolder(\""+tree.getID()+"\",\""+this.getID()+"\")'"

    str = str + ">"
  } 
  else{
    if (browserVersion > 0 &&this.level!=0) 
      link = "<a class='ExplorerFolder' href='javascript:clickOnNode(\""+tree.getID()+"\",\""+this.getID()+"\")'>" 
    else 
      link = "<a class='ExplorerFolder'>" 
    str=str+link;
  }
  return str;
} 
 
function addChild(childNode) 
{ 
  this.children[this.numberOfChildren] = childNode 
  childNode.parentObj = this
  this.numberOfChildren++ 
  return childNode 
} 

function addChildren(listOfChildren) 
{ 
  this.children = listOfChildren 
  this.numberOfChildren = listOfChildren.length
  for (i=0; i<this.numberOfChildren; i++)
    this.children[i].parentObj = this
} 

function folderSubEntries() 
{ 
  var i = 0 
  var se = this.numberOfChildren 
 
  for (i=0; i < this.numberOfChildren; i++){ 
    if (this.children[i].children) //entry is a folder 
      se = se + this.children[i].subEntries() 
  } 
 
  return se 
} 

function nodeImageSource() {
  var srcStr = "";

  if (this.isLastNode) //the last child 
  { 
    if (this.numberOfChildren == 0)
      srcStr = ImagePath + "lastnode.gif"
    else
      if (this.isOpen)
        srcStr = ImagePath + "mlastnode.gif"  
      else
        srcStr = ImagePath + "plastnode.gif"  
  } 
  else 
  { 
    if (this.numberOfChildren == 0)
      srcStr = ImagePath + "node.gif"
    else
      if (this.isOpen)
        srcStr = ImagePath + "mnode.gif"
      else
        srcStr = ImagePath + "pnode.gif"
  }   
  return srcStr;
}

function folderImageSrc() {
  if (this.isOpen)
    return(this.iconSrc)
  else
    return(this.iconSrcClosed)
} 
 
function Item(itemDescription) // Constructor 
{ 
  // constant data 
  this.description= itemDescription 

  this.level = 0
  this.isLastNode = false
  this.leftSideCoded = ""
  this.parentObj = null

  this.maySelect=true

  this.initialize = initializeItem;
  this.createIndex = createEntryIndex;
  this.forceOpenFolders = forceOpenFolders;

  finalizeCreationOfItem(this)
} 

function finalizeCreationOfItem(itemArray)
{
  itemArray.navigationObject = 0 
  itemArray.folderImage = 0
  itemArray.iconSrc = ImagePath + "document.gif" 
  itemArray.isDisplayed = 0
  itemArray.numberOfChildren = 0
  itemArray.additionalHTML = ""
 
  itemArray.setVisibility = setVisibility
  itemArray.redraw = setVisibility
  itemArray.folderMstr = folderMstr 
  itemArray.displayObject = drawItem 
  itemArray.totalHeight = totalHeight 
  itemArray.startHTML = startHTML
  itemArray.endHTML = endHTML
  itemArray.getID = getID
}

function initializeItem(tree,level, lastNode, leftSide) 
{  
  this.id=-1
  this.createIndex(tree) 
  this.level = level
  this.leftSideCoded = leftSide
  this.isLastNode = lastNode
} 
 
function drawItem(tree,insertAtObject) 
{ 
  var leftSide = leftSideHTML(this.leftSideCoded)
  var str = ""

  var fullLink = "href=\""+this.link+"\" target=\""+this.target+"\" onClick=\"clickOnLink('"+tree.getID()+"','"+this.getID()+"\', '"+this.link+"','"+this.target+"');return false;\"";
  this.isDisplayed = 1

  if (this.level>0) 
    if (this.isLastNode) //the last 'brother' in the children array 
    { 
      leftSide = leftSide + "<td valign=top><img src='" + ImagePath + "lastnode.gif' width=16 height=22></td>"
    } 
    else 
    { 
      leftSide = leftSide + "<td valign=top background=" + ImagePath + "vertline.gif><img src='" + ImagePath + "node.gif' width=16 height=22></td>"
    } 
  str = str + this.startHTML("item",tree)

  str = str + "<tr>" + leftSide + "<td valign=top>"
  if (tree.UseFolderIcons)
      str = str + "<a class='ExplorerLink' " + fullLink  + " id=\"itemIconLink"+tree.getID()+this.id+"\">" + "<img id='itemIcon"+tree.getID()+this.id+"' " + "src='"+this.iconSrc+"' border=0>" + "</a>"
  else if (this.additionalHTML == "")
      str = str + "<img src=" + ImagePath + "blank.gif height=2 width=3>"

  if (tree.WrapText)
    str = str + "</td>"+this.additionalHTML+"<td valign=middle width=100%>"
  else
    str = str + "</td>"+this.additionalHTML+"<td valign=middle nowrap width=100%>"

  if (TextAsLink) 
    str = str + "<a class='ExplorerLink' " + fullLink + " id=\"itemTextLink"+tree.getID()+this.id+"\">" + this.description+ "</a>"
  else 
    str = str + this.desc

  str = str + "</td>"

  str = str + this.endHTML()
 
  if (insertAtObject == null)
  {
	  document.write(str)
  }
  else
  {
      insertAtObject.insertAdjacentHTML("afterEnd", str)
  }

  if (browserVersion == 2) { 
    this.navigationObject = document.layers["item"+this.id+tree.getID()] 
    if (tree.UseFolderIcons)
      this.folderImage = this.navigationObject.document.images["itemIcon"+this.id+tree.getID()] 
    document.yPosition=document.yPosition+this.navigationObject.clip.height 
  } else if (browserVersion != 0) { 
    this.navigationObject = getElById("item"+this.id+tree.getID())
    if (tree.UseFolderIcons)
      this.folderImage = getElById("itemIcon"+this.id+tree.getID())
  } 
} 
 
 

function forceOpenFolders(tree) {
  if (this.parentObj == null || this.parentObj.isOpen)
    return
  else {
    this.parentObj.forceOpenFolders(tree)
    clickOnNodeObject(tree,this.parentObj)
  }
}

function setVisibility() 
{ 
  if (browserVersion == 1 || browserVersion == 3) { 
    if (this.navigationObject.style.display == "none") 
      return 
    this.navigationObject.style.display = "none" 
  } else { 
    if (this.navigationObject.visibility == "hidden") 
      return 
    this.navigationObject.visibility = "hidden" 
  }     
} 
 
function folderMstr(tree,domObj) 
{ 
  if (!this.isDisplayed){
     this.displayObject(tree,domObj)
  }
  else
    if (browserVersion == 1 || browserVersion == 3) 
      this.navigationObject.style.display = "block" 
    else 
      this.navigationObject.visibility = "show" 
} 

function startHTML(idprefix,tree) {
  var idParam = "id='" + idprefix + this.id +tree.getID()+ "'"
  var str = ""
  if (browserVersion == 2) 
    str = "<layer "+ idParam + " top=" + document.yPosition + " visibility=show>"
  else if (browserVersion != 0)
    str = "<div " + idParam + " style='display:block; position:block;'>"
     
  str = str + "<table border=0 cellspacing=0 cellpadding=0 width=100% >"

  return str
}

function endHTML() {
  var str = ""

  str = "</table>"
   
  if (browserVersion == 2) 
    str = str + "</layer>"
  else if (browserVersion != 0)
    str = str + "</div>"

  return str
}
 
function createEntryIndex(tree) 
{ 
  if(this.id==-1)
    this.id = tree.numberOfEntries 
  tree.indexOfEntries[tree.numberOfEntries] = this 
  tree.numberOfEntries++ 
} 
 
function totalHeight() //used with browserVersion == 2 
{ 
  var h = this.navigationObject.clip.height 
  var i = 0 
   
  if (this.isOpen) //is a folder and _is_ open 
    for (i=0 ; i < this.numberOfChildren; i++)  
      h = h + this.children[i].totalHeight() 
 
  return h 
} 


function leftSideHTML(leftSideCoded) {
	var i;
	var retStr = "";

	for (i=0; i<leftSideCoded.length; i++)
	{
		if (leftSideCoded.charAt(i) == "1")
		{
			retStr = retStr + "<td valign=top background=" + ImagePath + "vertline.gif><img src='" + ImagePath + "vertline.gif' width=16 height=22></td>"
		}
		if (leftSideCoded.charAt(i) == "0")
		{
			retStr = retStr + "<td valign=top><img src='" + ImagePath + "blank.gif' width=16 height=22></td>"
		}
	}
	return retStr
}

function getID()
{
  if (typeof this.externalID != "undefined") 
    return this.externalID
  else
    return this.id
}

function clickOnFolder(tree,folderId) 
{ 
  var clicked = findObj(tree,folderId)
  if (typeof clicked=='undefined' || clicked==null)
  {
//    alert("Explorer was not able to find the node object corresponding to ID=" + folderId + ".")
    return;
  }

  if (!clicked.isOpen) {
    clickOnNodeObject(tree,clicked) 
  }

  if (tree.lastOpenedFolder != null && tree.lastOpenedFolder != folderId)
    clickOnNode(tree.getID(),tree.lastOpenedFolder); //sets lastOpenedFolder to null

  if (clicked.numberOfChildren==0) {
    tree.lastOpenedFolder = folderId;
    clicked.isLastOpenedfolder = true
  }

  if (isLinked(clicked.hreference)) {
      highlightObjLink(tree,clicked);
  }
} 
 
function clickOnNode(treeid,folderId) 
{ 
var tree=getTree(treeid)

  fOb = findObj(tree,folderId);
  if (typeof fOb=='undefined' || fOb==null)
  {
//    alert("Explorer was not able to find the node object corresponding to ID=" + folderId + ".")
    return;
  }

  clickOnNodeObject(tree,fOb);
}

function clickOnNodeObject(tree,folderObj) 
{ 
  var state = 0 
  var currentOpen
 
  state = folderObj.isOpen 
  folderObj.setState(tree,!state) //toggle open/close  

  if (folderObj.id!=tree.id && tree.KeepState)
  {
    currentOpen = GetCookie(tree,"clickedFolder")
    if (currentOpen == null)
      currentOpen = ""

    if (!folderObj.isOpen) //closing
    {
      currentOpen = currentOpen.replace(folderObj.getID()+cookieCutter, "")
      SetCookie(tree,"clickedFolder", currentOpen)
    }
    else
      SetCookie(tree,"clickedFolder", currentOpen+folderObj.getID()+cookieCutter)
  }
}

function clickOnLink(treeid,clickedId, target, windowName) {
var tree=getTree(treeid)
    highlightObjLink(tree,findObj(tree,clickedId));
    if (isLinked(target)) {
        window.open(target,windowName);
    }
}

function finalizeCreationOfChildDocuments(folderObj) {
  for(i=0; i < folderObj.numberOfChildren; i++)  {
    child = folderObj.children[i]
    if (typeof child[0] != 'undefined')
    {
      child.description= child[0] 
      finalizeCreationOfItem(child)
    }
  }
}

function findObj(tree,id)
{
  var i=0;
  var nodeObj;
  if (typeof tree.externalID != "undefined") {
    nodeObj = tree.indexOfEntries[i];
    for(i=0;i<tree.numberOfEntries&&tree.indexOfEntries[i].externalID!=id;i++) 
      ;
    id = i
  }
  if (id >= tree.numberOfEntries)
    return null; 
  else{
    if(tree.indexOfEntries!=null)
      return tree.indexOfEntries[id];
  }
}

function isLinked(hrefText) {
    var result = true;
    result = (result && hrefText !=null);
    result = (result && hrefText != '');
    result = (result && hrefText.indexOf('undefined') < 0);
    result = (result && hrefText.indexOf('parent.op') < 0);
    return result;
}

function highlightObjLink(tree,nodeObj) {
  if (!HighLight || nodeObj==null || nodeObj.maySelect==false) {
    return;
  }
  if (browserVersion == 1 || browserVersion == 3) {
    var clickedDOMObj = getElById('itemTextLink'+tree.getID()+nodeObj.id);
    if (clickedDOMObj != null) {
        if (tree.lastClicked != null) {
            var prevClickedDOMObj = getElById('itemTextLink'+tree.getID()+tree.lastClicked.id);
            prevClickedDOMObj.style.color=tree.lastClickedColor;
            prevClickedDOMObj.style.backgroundColor=tree.lastClickedBgColor;
        }
        
        tree.lastClickedColor    = clickedDOMObj.style.color;
        tree.lastClickedBgColor  = clickedDOMObj.style.backgroundColor;
        clickedDOMObj.style.color=HighLightColor;
        clickedDOMObj.style.backgroundColor=HighLightBackgroundColor;
    }
  }
  tree.lastClicked = nodeObj;
  if (tree.KeepState)
    SetCookie(tree,'highlightedExplorerLink', nodeObj.getID());
}

function insertField(parentFolder, childFolder) 
{ 
  return parentFolder.addChild(childFolder) 
} 
 
function insertDocument(parentFolder, document) 
{ 
  return parentFolder.addChild(document) 
} 

function insertFolder(description,target, hreference) 
{ 
  folder = new Folder(description,target,hreference);
  return folder;
} 
 
function insertLink(target,description, linkData) 
{ 
  newItem = new Item(description);
  newItem.link   = linkData;    
  newItem.target = target
  return newItem;
} 

function preLoadIcons() {
	var auxImg
	auxImg = new Image();
	auxImg.src = ImagePath + "vertline.gif";
	auxImg.src = ImagePath + "mlastnode.gif";
	auxImg.src = ImagePath + "mnode.gif";
	auxImg.src = ImagePath + "plastnode.gif";
	auxImg.src = ImagePath + "pnode.gif";
	auxImg.src = ImagePath + "blank.gif";
	auxImg.src = ImagePath + "lastnode.gif";
	auxImg.src = ImagePath + "node.gif";
	auxImg.src = ImagePath + "folderclosed.gif";
	auxImg.src = ImagePath + "folderopen.gif";
	auxImg.src = ImagePath + "document.gif";
}

function setInitialLayout(tree) {
  if (browserVersion > 0 && !tree.StartAllExpanded)
    clickOnNodeObject(tree,tree);
  
  if (!tree.StartAllExpanded && (browserVersion > 0) && tree.KeepState)
		PersistentFolderOpening(tree);
}

function displayWholeTree(tree,nodeObj, parent) {
  var i=0;
  nodeObj.displayObject(tree,parent)
  if (supportsDeferral)
    for (i=nodeObj.numberOfChildren-1; i>=0; i--) 
      displayWholeTree(tree,nodeObj.children[i], nodeObj.navigationObject)
  else
    for (i=0 ; i < nodeObj.numberOfChildren; i++) 
      displayWholeTree(tree,nodeObj.children[i], null)
}

function hideWholeTree(nodeObj, hideThisOne, nodeObjMove) {
  var i=0;
  var heightContained=0;
  var childrenMove=nodeObjMove;

  if (hideThisOne)
    nodeObj.setVisibility()

  if (browserVersion == 2)
    nodeObj.navigationObject.moveBy(0, 0-nodeObjMove)

  for (i=0 ; i < nodeObj.numberOfChildren; i++) {
    heightContainedInChild = hideWholeTree(nodeObj.children[i], true, childrenMove)
    if (browserVersion == 2) {
      heightContained = heightContained + heightContainedInChild + nodeObj.children[i].navigationObject.clip.height
      childrenMove = childrenMove + heightContainedInChild
	}
  }

  return heightContained;
}

 
if(typeof HTMLElement!="undefined" && !HTMLElement.prototype.insertAdjacentElement){
	HTMLElement.prototype.insertAdjacentElement = function (where,parsedNode)
	{
		switch (where){
		case 'beforeBegin':
			this.parentNode.insertBefore(parsedNode,this)
			break;
		case 'afterBegin':
			this.insertBefore(parsedNode,this.firstChild);
			break;
		case 'beforeEnd':
			this.appendChild(parsedNode);
			break;
		case 'afterEnd':
			if (this.nextSibling) 
				this.parentNode.insertBefore(parsedNode,this.nextSibling);
			else this.parentNode.appendChild(parsedNode);
			break;
		}
	}
	HTMLElement.prototype.insertAdjacentHTML = function(where,htmlStr)
	{
		var r = this.ownerDocument.createRange();
		r.setStartBefore(this);
		var parsedHTML = r.createContextualFragment(htmlStr);
		this.insertAdjacentElement(where,parsedHTML)
	}
}

function getElById(idVal) {
  if (document.getElementById != null)
    return document.getElementById(idVal)
  if (document.all != null)
    return document.all[idVal]
//  alert("Problem getting element by id")
  return null
}


// The separator currently in use is ^ (chr 94)
function PersistentFolderOpening(tree)
{
  var stateInCookie;
  var fldStr=""
  var fldArr
  var fldPos=0
  var id
  var nodeObj
  stateInCookie = GetCookie(tree,"clickedFolder");
  SetCookie(tree,'clickedFolder', "")
  if(stateInCookie!=null)
  {
    fldArr = stateInCookie.split(cookieCutter)
    for (fldPos=0; fldPos<fldArr.length; fldPos++)
    {
      fldStr=fldArr[fldPos]
      if (fldStr != "") {
        nodeObj = findObj(tree,fldStr)
        if (nodeObj!=null)
          if (nodeObj.setState) {
            nodeObj.forceOpenFolders(tree)
            clickOnNodeObject(tree,nodeObj);

          }
//          else
//            alert("Internal id is not pointing to a folder anymore. Consider using external IDs")
      }
    }
  }
}

function storeAllNodesInClickCookie(tree,treeNode)
{
  var currentOpen
  var i = 0

  if (typeof treeNode.setState != "undefined") 
  {
    currentOpen = GetCookie(tree,"clickedFolder")
    if (currentOpen == null)
      currentOpen = ""

    if (treeNode.getID() != tree.getID())
      SetCookie(tree,"clickedFolder", currentOpen+treeNode.getID()+cookieCutter)

    for (i=0; i < treeNode.numberOfChildren; i++) 
        storeAllNodesInClickCookie(tree,treeNode.children[i])
  }
}

/*Cookie functions */
function CookieName(tree,name) {
  if (typeof tree.treeID != "undefined")
    return name+tree.treeID
  else
    return name
}
 
function GetCookie(tree,name)
{  
name = CookieName(tree,name)

var arg = name + "=";  
var alen = arg.length;  
var clen = document.cookie.length;  
var i = 0;  

  while (i < clen) {    
    var j = i + alen;    
    if (document.cookie.substring(i, j) == arg)      
      return getCookieVal (j);    
    i = document.cookie.indexOf(" ", i) + 1;    
    if (i == 0) break;   
  }  
  return null;
}

function getCookieVal(offset) {  
	var endstr = document.cookie.indexOf (";", offset);  
	if (endstr == -1)    
	endstr = document.cookie.length;  
	return unescape(document.cookie.substring(offset, endstr));
}

function SetCookie(tree,name, value) 
{  
  var argv = SetCookie.arguments;  
  var argc = SetCookie.arguments.length;  
  var expires = (argc > 3) ? argv[3] : null;  
  var domain = (argc > 5) ? argv[5] : null;  
  var secure = (argc > 6) ? argv[6] : false;  
  var path = "/"; //allows the tree to remain open across pages with diff names & paths
  name = CookieName(tree,name)
  document.cookie = name + "=" + escape (value) + 
 ((expires == null) ? "" : ("; expires=" + expires.toGMTString())) + 
 ((path == null) ? "" : ("; path=" + path)) +  
 ((domain == null) ? "" : ("; domain=" + domain)) +    
 ((secure == true) ? "; secure" : "");
}

function ExpireCookie (tree,name) 
{  
  var exp = new Date();  
  exp.setTime (exp.getTime() - 1);  
  var cval = GetCookie (tree,name);  
  name = CookieName(tree,name)
  document.cookie = name + "=" + cval + "; expires=" + exp.toGMTString();
}
/*Cookie functions */


//To customize the tree, overwrite these variables in the configuration file
var TextAsLink = 0;
var UseFrames = 1;
var ImagePath = '';
var HighLight = 0;
var HighLightColor = 'white';
var HighLightBackgroundColor    = 'blue';
var BuildAll = 0;
var DefaultTarget = "_blank";


//Other variables
var browserVersion = 0 
var supportsDeferral = false
var cookieCutter = '^' 

document.yPosition = 0

// Main function
// ************* 

var trees=null;
function addTree(tree)
{
var id=tree.getID();
  if(trees==null)
    trees=new Array();
  for(i=0;i<trees.length;i++){
    if(trees[i]==id)
      return;    
  }
  trees[i]=tree;
  tree.lastClicked=null;
  tree.indexOfEntries = new Array 
  tree.numberOfEntries = 0 
  tree.selectedFolder=0
  tree.lastOpenedFolder=null
}

function getTree(id)
{
  for(i=0;i<trees.length;i++){
    if(trees[i].getID()==id)
      return trees[i];
  }
  return null;
}

function getBrowserVersion()
{
var browserVersion;
  switch(navigator.family)
  {
    case 'ie4':
      browserVersion = 1 //Simply means IE > 3.x
      break;
    case 'opera':
      browserVersion = (navigator.version > 6 ? 1 : 0); //opera7 has a good DOM
      break;
    case 'nn4':
      browserVersion = 2 //NS4.x 
      break;
    case 'gecko':
      browserVersion = 3 //NS6.x
      break;
    case 'safari':
      browserVersion = 1 //Safari Beta 3 seems to behave like IE
      break;
	default:
      browserVersion = 0 //other, possibly without DHTML  
      break;
  }
  return browserVersion;
}

function initializeDocument(tree) 
{ 
  addTree(tree);
  preLoadIcons();
  browserVersion=getBrowserVersion(); 

  supportsDeferral = ((navigator.family=='ie4' && navigator.version >= 5 && navigator.OS != "mac") || browserVersion == 3);
  supportsDeferral = supportsDeferral & (!BuildAll)
  if (!UseFrames && browserVersion == 2)
  	browserVersion = 0;
 
  if (tree.KeepState && GetCookie(tree,"clickedFolder") != null)
    tree.StartAllExpanded = 0


  tree.initialize(tree,0, true, "") 
 if (supportsDeferral && !tree.StartAllExpanded) {
      tree.displayObject(tree,null) 
  }

  else {
    displayWholeTree(tree,tree,null);

    if (tree.KeepState && tree.StartAllExpanded)
      storeAllNodesInClickCookie(tree,tree)

    if (browserVersion == 2) 
      document.write("<layer top=" + tree.indexOfEntries[tree.numberOfEntries-1].navigationObject.top + ">&nbsp;</layer>") 

    if (browserVersion != 0 && !tree.StartAllExpanded)
      hideWholeTree(tree, false, 0)
  }
 
  setInitialLayout(tree)
  if (tree.KeepState && GetCookie(tree,'highlightedExplorerLink')!=null  && GetCookie(tree,'highlightedExplorerLink')!="") {
    var nodeObj = findObj(tree,GetCookie(tree,'highlightedExplorerLink'))
    if (nodeObj!=null){
      nodeObj.forceOpenFolders(tree)
      highlightObjLink(tree,nodeObj);
    }
    else
      SetCookie(tree,'highlightedExplorerLink', '')
  }
} 
 